

; PictView v1.1
; By Kaid [kaid@excite.fr]




#DEFINE TITRE "PictView",0
.INCLUDE ZSHELL83.INC

POS_MENU     = saferam3         ;Position dans le menu
NB_FICHIERS  = saferam3+1       ;Nombre de fichiers trouvs
NUM_PAGE     = saferam3+2       ;Numro de la "page" courante
MAX_PAGES    = saferam3+3       ;Numro maximum de "pages"                                
TAB_FICHIERS = saferam3+4       ;Tableau d'adresses des fichiers

; * Recherche des fichiers dans la VAT * 

        XOR A                   ;
        LD (NB_FICHIERS),A      ;On met  zro le nombre de fichiers trouvs

        LD IX,TAB_FICHIERS      ;Tableau o vont tre stock les adresses
        LD HL,(vat)             ;Recherche dans la VAT


Cherche_Boucle:

        PUSH IX
        LD IX,Str_Dct           ;IX pointe sur la chaine de dtection
        CALL ionDetect          ;Fonction de recherche
        POP IX
        JR NZ,Cherche_Fin       ;Si !ZF, plus de fichiers

        LD (IX),L               ;
        INC IX                  ;
        LD (IX),H               ;
        INC IX                  ;Stocke l'adresse du programme

        LD HL,NB_FICHIERS       ;
        INC (HL)                ;Incrmente le nombre de fichiers trouvs

        EX DE,HL                ;Echange DE et HL. 
        JR Cherche_Boucle


Cherche_Fin:

; * Fin de la recherche *

        XOR A                   ;
        LD (IX),A               ;
        INC IX                  ;
        LD (IX),A               ;On stocke un NULL  la fin du tableau


        SET 7,(IY+$14)          ;Pour crire aussi dans la mmoire vido
        CALL IniEcran           ;Initialise l'cran
     
        XOR A
        LD HL,NB_FICHIERS

        CP (HL)                 ;Si (HL) est diffrent de 0, alors il y a des
        JR NZ,ImagesPresentes   ; fichiers pour PictView

; * Pas de fichiers *

        bcall(_copygbuf)        ;On affiche le buffer graphique

        LD HL,$0403             ;
        LD (CURSOR_ROW),HL      ;
        LD HL,Str_P_I           ;                        
        bcall(D_ZT_STR)         ;Affiche "No files"

        CALL AttendTouche       ;Attend la pression d'une touche

Quitte:
        RES 7,(IY+$14)
        RET                     ;Retourne au shell

; * Il y a des images *
ImagesPresentes:

        LD B,7                  ;Nombre maximum de fichiers par "page"
        LD C,0                  ;Compteur de pages

        LD A,(HL)               ;Nombre d'images

ComptePages_Boucle:
        CP B                    
        JR C, FinComptePages
        JR Z, FinComptePages

        SUB B
        INC C
        JR ComptePages_Boucle   ;Compte le nombre de page

FinComptePages:

        LD (HL),A               ;On met  jour le nombre de fichiers sur la dernire page

        LD HL,MAX_PAGES         ;
        LD (HL),C               ;On sauve le numro de page maxi


        XOR A                   ;
        LD (NUM_PAGE),A         ;Numro de la page courante

InitPosMenu:
        XOR A                   ;
        LD (POS_MENU),A         ;Initialise la position dans le menu

; * Menu *
DessineMenu:

        CALL IniEcran           ;Initialise l'cran
        CALL AffFichiers        ;Affiche les images
        LD DE,POS_MENU          ;DE pointe sur POS_MENU 

; * Boucle du menu *
BoucleMenu:
        CALL Inv_Barre          ;Inverse la barre de menu
        PUSH DE
        bcall(_copygbuf)        ;On affiche le buffer graphique
        POP DE

BoucleKey:
        PUSH DE                 ;
        CALL AttendTouche       ;Attend la pression d'une touche
        POP DE                  ;

        CALL Inv_Barre          ;Inverse la barre de menu
                
        CP G_MODE               ;Si [MODE]
        JR Z,Quitte             ;On quitte PictView

        CP G_UP                 ;Si [UP]
        JR Z,MenuMonte          ;Monte d'un choix 

        CP G_DOWN               ;Si [DOWN]
        JR Z,MenuDescend        ;Descend d'un choix 

        CP G_RIGHT              ;Si [RIGHT]
        JR Z,PageSuivante       ;Passe  la page suivante

        CP G_ENTER              ;Si pas [ENTER]
        JR NZ,BoucleMenu        ;On attend la prochaine touche


AfficheImg:
;* [ENTER] presse => Affichage *

        PUSH DE                 ;On sauve DE

        LD A,(NUM_PAGE)         ;
        LD L,A \ LD H,14        ;Position du premier fichier 
        bcall(MUL_HL)           ; correspondant  la page

        POP DE
        LD A,(DE)               ;A=Position dans le menu

        LD DE,TAB_FICHIERS      ;DE pointe sur le tableau d'adresses
        ADD HL,DE               ;On effectue le dcalage

AjustImg:
        OR A                    ;Si A=0, HL pointe sur la bonne image
        JR Z,AjustImg_Fin

        INC HL \ INC HL         ;Pointe sur la prochaine adresse
        DEC A                   ;Dcrmente notre compteur
        JR AjustImg

AjustImg_Fin:

        PUSH HL                 ;
        bcall(_cleargbuf)       ;
        POP HL                  ;Efface le buffer cran

        bcall(LD_HL_MHL)        ;HL Pointe sur le commentaire de l'image
        XOR A
        CPIR                    ;Il pointe maintenant aprs ce commentaire

        LD DE,GRAPH_MEM 
                                ;DE Pointe sur l'image
        EX DE,HL                ;HL=GRAPH_MEM (Destination)

        CALL DecodeZCP          ;On dcompresse l'image
        bcall(_copygbuf)        ;On affiche le buffer graphique

        CALL AttendTouche       ;Attend la pression d'une touche
        bcall(_cleargbuf)       ;Efface le buffer cran
        JR DessineMenu          ;On retourne au menu


; * Monte d'un choix dans le menu *
MenuMonte:
        LD A,(DE)

        OR A                    ;Si nous sommes sur le premier choix, 
        JR Z,BoucleMenu         ; on ne peux aller plus haut

        DEC A
        JR Maj_Pos_Menu         


; * Descend d'un choix dans le menu *
MenuDescend:

        LD A,(NUM_PAGE)         ;
        LD B,A                  ;
        LD A,(MAX_PAGES)        ;
        CP B                    ;On recherche le nombre de fichiers contenus
        JR NZ, Max_7            ; dans la page

        LD A,(NB_FICHIERS)      ;
        LD B,A                  ;C'est le nombre stock dans NB_FICHIERS

        JR Maj_NbFichiers
Max_7:
        LD B,7                  ;Il y en a 7

Maj_NbFichiers:

        LD A,(DE)
        
        INC A

        CP B                    ;Si nous sommes aprs le dernier choix,
        JR Z,BoucleMenu         ; dplacement impossible
Maj_Pos_Menu:

        LD (DE),A               ;Mise  jour de la nouvelle position

        PUSH DE
        bcall(_copygbuf)        ;On affiche le buffer graphique
        POP DE
        JR BoucleMenu           ;Boucle sur le menu
        

; * Passage  la page suivante *
PageSuivante:

        LD A,(MAX_PAGES)        ;
        LD B,A                  ; 
        LD A,(NUM_PAGE)         ;
        CP B                    ;Si nous sommes sur la dernire page, on
        JR Z,PremierePage       ; retourne  la premire

        INC A                   ;On incrmente le numro de page
        JR Maj_NumPage

PremierePage:
        XOR A                   ;Retourne  la premire page

Maj_NumPage:
        LD (NUM_PAGE),A         ;On met  jour le numro de page
        JP InitPosMenu          ;On va r-initialiser le menu
        

; * Inverse la barre du menu *
Inv_Barre:
        PUSH AF
        PUSH DE

        LD A,(POS_MENU)         ;
        LD L,A \ LD H,96        ;
        bcall(MUL_HL)           ;HL=POS_MENU*96

        LD DE,GRAPH_MEM+96      ;On dcale  cause du titre 
        ADD HL,DE               
        LD B,7*12               ;Nombre d'octets  "inverser"

Inv_Barre_Boucle:
        LD A,(HL)               ;
        XOR $FF                 ;
        LD (HL),A               ;On "inverse" un octect
        INC HL
        DJNZ Inv_Barre_Boucle

        POP DE
        POP AF

        RET
        
; * Initialise l'cran *
IniEcran:

        bcall(_cleargbuf)       ;Efface le buffer cran

        LD HL,$0018             ;
        LD (CURSOR_X),HL        ;
        LD HL,Str_Tit           ;
        bcall(D_ZM_STR)         ;Affiche le titre

        RET

; * Affiche les fichiers PictView *
AffFichiers:

        LD A,(NUM_PAGE)         ;
        LD L,A \ LD H,14        ;Position du premier fichier 
        bcall(_htimesl)         ; correspondant  la page

        LD DE,TAB_FICHIERS      ;Pointe sur le tableau d'adresses

        ADD HL,DE               ;On effectue le dcalage

        LD DE,$0802             ;Position initiale du curseur
        LD B,7                  ;On affiche un maximun de 7 fichiers

AffFichiers_Boucle:

        PUSH DE \ PUSH HL       ;
        bcall(LD_HL_MHL)        ;
        LD DE,0                 ;
        bcall(CP_HL_DE)         ;Si le prochain pointeur stock est le 
        POP HL \ POP DE         ; le pointeur NULL, alors il n'y a plus 
        RET Z                   ; de fichiers  afficher, on sort

        PUSH HL

        bcall(LD_HL_MHL)        ;HL pointe sur le commentaire de l'image
        PUSH DE                 ;On sauve DE (Pos. du curseur)
        LD (CURSOR_X),DE                
        bcall(D_ZM_STR)         ;On affiche le commentaire
        POP DE

        LD A,D \ ADD A,8 \ LD D,A ;Passe le curseur  la ligne suivante

        POP HL

        INC HL \ INC HL         ;HL pointe sur la prochaine adresse

        DJNZ AffFichiers_Boucle ;B-- et boucle tant que B!=0
        RET


; * Attend la pression d'une touche *
AttendTouche:
        bcall(GET_KEY)

        OR A
        JR Z,AttendTouche
        RET

Str_Tit .DB "PictView - Kaid",0
Str_P_I .DB "No files",0
Str_Dct .DB "PV10",0

.INCLUDE ZCPDECOD.ASM
.END
